// Combinatorics.java

import java.lang.*;
import java.awt.*;

public class Combinatorics {
	
	String[] set;
	String[] perm;
	DLList setList;
	int[] order;
	int size;
	JRandom myRand;
	
	public Combinatorics() {
		myRand = new JRandom();
	}
	
	public Combinatorics(String[] s) {
		myRand = new JRandom();
		size  = s.length;
		set = new String[size];
		perm = new String[size];
		order = new int[size];
		for (int i = 0; i < size; i++) {
			set[i] = s[i];	
		}
	}
	
	public static int fact(int n) {
		int f = 1;
		for (int i = 1; i <= n; i++)
		{
			f *= i;	
		}	
		return f;
	}
	
	public static int choose(int n, int k) {
		float results = 1;
		for (int i = 0; i < k; i++) {
			results *= n - i;
			results /= k - i;	
		}
		return (int) results;
	}
	
	public static float bernoulli(int n, float p, int k) {
		float results = 1;
		int i;
		for (i = 0; i < k; i++) {
			results *= n - i;
			results /= k - i;
			results *= p;
			if (i < n - k)
				results *= (1 - p);	
		}
		if (i < n - k)
			results *= Math.pow((double) (1 - p), (double) ((n - k) - i));
		return (float) results;
	}
	
	public String[] randPerm() {
		setList = new DLList(set);
		nextElem(size, size);
		for (int i = 0; i < size; i++) {
			setList.start();
			setList.step(order[i]);
			perm[i] = setList.remove();
		}
		return perm;
	}
	
	public void nextElem(int n, int s) {
		order[s - n] = myRand.nextInt(0, n - 1);
		if (n != 1) {
			nextElem(n - 1, s);
		}	
	}
	
	// print out all permutations to a textArea. Only prints indexes, but starts with 1
	public void allPerm(TextArea out) {
		allElem(out, size, size);
	}
	
	// Ack!! no easy way to put in line breaks... Netscape sucks
	public void allElem(TextArea out, int n, int s) {
	
		//String temp = new String(out);
	
		for (int i = 0; i < n; i++) {
			order[s - n] = i;
			if (n != 1) {
				allElem(out, n - 1, s);			// Recurse
			}
			else {
				setList = new DLList(set);
				for (int j = 0; j < size; j++) {
					setList.start();
					setList.step(order[j]);			// For each last element, print out the current
					out.appendText(setList.remove());	// permutation, 1 - n
				}
				if (out.getText().length() % 80 > 80 - (s + 5))
					out.appendText("    \n");
				else 
					out.appendText("     ");
			}
		}
		//return temp;
	}	
}