// DLLFloat.java

public class DLLFloat {
	
	Node first;
	Node last;
	Node cur;
	int length;
	
	public DLLFloat() {
		length = 0;
		first = null;
		last = null;
		cur = null;
	}
	
	public DLLFloat(Float[] e) {
		length = 0;
		for (int i = 0; i < e.length; i++) {
			add(e[i]);	
		}
	}
	
	public void start() {
		cur = first;
	}
	
	public void end() {
		cur = last;
	}
	
	public void add(Float elem) {
		if (first == null) {
			first = new Node(elem);
			cur = first;
			last = first;
		}
		else {
			Node temp = new Node(elem);
			temp.next = cur.next;
			temp.prev = cur;
			if (temp.next != null)
				temp.next.prev = temp;
			else
				last = temp;
			cur.next = temp;
			cur = cur.next;
		}
		length++;
	}
	
	public Float curVal() {
		return cur.val;
	}
	
	public void setCurVal(Float v) {
		cur.val = v;	
	}
	
	public Float remove() {
		Float v = cur.val;
		if (cur.next == null && cur.prev != null) {
			cur.prev.next = null;
			last = cur.prev;
		}
		else if (cur.prev == null && cur.next != null) {
			first = cur.next;
			cur.next.prev = null;
			cur = cur.next;
		}
		else if (cur.prev == null && cur.next == null) {
			cur = null;
			first = null;
			last = null;
		}
		else {
			cur.next.prev = cur.prev;
			cur.prev.next = cur.next;
			cur = cur.next;
		}
		length--;
		return v;
	}
	
	public void step(int n) {
		for (int i = 0; i < n; i++) {
			if (cur.next != null)
				cur = cur.next;	
		}
	}
	
	public void back(int n) {
		for (int i = 0; i < n; i++) {
			if (cur.prev != null)
				cur = cur.prev;	
		}
	}
	
	public Float[] toArray() {
		start();
		Float[] temp = new Float[length];
		for (int i = 0; i < length; i++) {
			temp[i] = curVal();
			step(1);
		}
		return temp;
	}
}

class Node {
	Node prev;
	Node next;
	Float val;
	
	public Node() {
		val = new Float(0);
		prev = null;
		next = null;
	}	
	
	public Node(Float v) {
		val = v;
		prev = null;
		next = null;
	}
}