// DLList.java

public class DLList {
	
	Node first;
	Node cur;
	int length;
	
	public DLList() {
		length = 0;
		first = null;
		cur = null;
	}
	
	public DLList(String[] e) {
		length = 0;
		for (int i = 0; i < e.length; i++) {
			add(e[i]);	
		}
	}
	
	public void start() {
		cur = first;
	}
	
	public void add(String elem) {
		if (first == null) {
			first = new Node(elem);
			cur = first;
		}
		else {
			Node temp = new Node(elem);
			temp.next = cur.next;
			temp.prev = cur;
			if (temp.next != null)
				temp.next.prev = temp;
			cur.next = temp;
			cur = cur.next;
		}
		length++;
	}
	
	public String remove() {
		String s = cur.val;
		if (cur.next == null && cur.prev != null) 
			cur.prev.next = null;
		else if (cur.prev == null && cur.next != null) {
			first = cur.next;
			cur.next.prev = null;
			cur = cur.next;
		}
		else if (cur.prev == null && cur.next == null) {
			cur = null;
			first = null;
		}
		else {
			cur.next.prev = cur.prev;
			cur.prev.next = cur.next;
			cur = cur.next;
		}
		length--;
		return s;
	}
	
	public void step(int n) {
		for (int i = 0; i < n; i++) {
			if (cur.next != null)
				cur = cur.next;	
		}
	}
	
}

class Node {
	Node prev;
	Node next;
	String val;
	
	public Node() {
		val = new String("");
		prev = null;
		next = null;
	}	
	
	public Node(String v) {
		val = v;
		prev = null;
		next = null;
	}
}