// GeneralSimulation.java

public class GeneralSimulation
{
	float probs[];
	float totalProb;
	String names[];
	int length;
	int numGames;
	int resultsExact[];
	float resultsPercent[];
	JRandom myRand;
	

	public GeneralSimulation(float[] p) {
		totalProb = 0.0f;
		length = p.length;
		probs = new float[length];
		names = new String[length];
		resultsExact = new int[length];
		resultsPercent = new float[length];
		for(int i = 0; i < length; i++)		// Copy arrays, and store total of probabilities
		{
			probs[i] = p[i];
			names[i] = String.valueOf(i + 1);
			totalProb += probs[i];
		}
		myRand = new JRandom();
	}

	public GeneralSimulation(float[] p, String[] n) {
		totalProb = 0.0f;
		length = p.length;
		probs = new float[length];
		names = new String[length];
		resultsExact = new int[length];
		resultsPercent = new float[length];
		for(int i = 0; i < length; i++)		// Copy arrays, and store total of probabilities
		{
			probs[i] = p[i];
			names[i] = n[i];
			totalProb += probs[i];
		}
		myRand = new JRandom();
	}
	
	// Simulate n trials, storing results in resultsExact and resultsPercent
	public void simulate(int n) {
		numGames = n;
		for (int i = 0; i < length; i++) {
			resultsExact[i] = 0;
		}
		float randFloat;
		for (int i = 0; i < n; i++) {
			randFloat = myRand.nextFloat(totalProb);
			int j = 0;
			while (randFloat > probs[j]) {
				randFloat -= probs[j];
				j++;
			}
			//System.out.println(j);
			resultsExact[j]++;
		}
		for (int i = 0; i < length; i++) {
			resultsPercent[i] = (float) resultsExact[i] / (float) numGames;
		}
	}
	
	// Return index for a single random experiment
	public int nextRand() {
		
		float randFloat = myRand.nextFloat(totalProb);
		int j = 0;
		while (randFloat > probs[j]) {
			randFloat -= probs[j];
			j++;
		}
		return j;
	}

	
}