import java.awt.*;


public class MultiLineGraph extends Graph {
	
	int segLength;

	public MultiLineGraph() {
		super();
	}
	
	public MultiLineGraph(Float[] x, Float[] y, int l) {
		super(x, y);
		segLength = l;
	}
	
	public void paint(Graphics g) {
	
		Font f;
		String fName;
		FontMetrics fm;
	
		if (length > 0) { 					// Make sure we have at least one point
			f = g.getFont();
			fName = f.getName();
			f = new Font(fName, Font.PLAIN, 9);
			g.setFont(f);
			fm = g.getFontMetrics();
		
			setPoints();				// When we are ready to paint, the dimensions of the component have been
			setTicks(true, fm);			// set, so we can calculate coordinates of all the points
			g.setColor(new Color(0, 0, 0));
			for (int i = 0; i < length - 1; i++) {		// For each point
				if ((i + 1) % segLength == 0)
					i++;
				g.drawLine(pixels[i].x, pixels[i].y, pixels[i + 1].x,
					pixels[i + 1].y);				// Connect it to the next point
			}
			
			drawXAxis(g);
			drawYAxis(g);
			g.setColor(new Color(150, 0, 0));			// Make ticks red
			drawTicks(g);
			g.setColor(new Color(0, 0, 100));			// Make labels blue
			labelTicks(g);
			g.setColor(new Color(0, 0, 0));
		}
	}	
}