import java.awt.*;


// LABEL ZERO!!!
public class SpikeGraph extends Graph {

	public SpikeGraph() {
		super();
	}
	
	public SpikeGraph(Float[] x, Float[] y) {
		super(x, y);
	}
	
	public void paint(Graphics g) {
		Font f;
		String fName;
		FontMetrics fm;
	
		if (length > 0) { 					// Make sure we have at least one point
			f = g.getFont();
			fName = f.getName();
			f = new Font(fName, Font.PLAIN, 9);
			g.setFont(f);
			fm = g.getFontMetrics();
		
			setPoints();				// When we are ready to paint, the dimensions of the component have been
			setTicks(false, fm);			// set, so we can calculate coordinates of all the points
			g.setColor(new Color(0, 0, 0));
			for (int i = 0; i < length; i++) {		// For each point
				g.drawLine(pixels[i].x, adjY(0), pixels[i].x, pixels[i].y);		// Make a spike
			}
			
			drawXAxis(g);
			g.setColor(new Color(150, 0, 0));			// Make ticks red
			drawTicks(g);
			g.setColor(new Color(0, 0, 100));			// Make labels blue
			labelTicks(g);
			g.setColor(new Color(0, 0, 0));
		}
	}	
}