// FixedVector.java

// Written by Julian Devlin, 8/97, for the text book
// "Introduction to Probability," by Charles M. Grinstead & J. Laurie Snell

import java.applet.Applet;
import java.awt.*;

public class FixedVector
	extends java.applet.Applet
{
	Label numl;			// Controls
	TextField num;
	
	Button create;
	
	FixedWindow fw;
	
	GridBagLayout gbl;
	GridBagConstraints cc;
		
	// Initialize applet
	public void init()
	{	
		numl = new Label("Matrix size = ");			// Create controls
		num = new TextField("5", 4);
		create = new Button("Create");
		
		gbl = new GridBagLayout();
		cc = new GridBagConstraints();
		setLayout(gbl);
		
		cc.gridx = 0;
		cc.gridy = 0;
		gbl.setConstraints(numl, cc);
		add(numl);
		
		cc.gridx = 1;
		gbl.setConstraints(num, cc);
		add(num);
		
		cc.gridx = 0;
		cc.gridy = 1;
		cc.gridwidth = 2;
		gbl.setConstraints(create, cc);
		add(create);
		
		validate();
	}
	
	// Handle events
	public boolean handleEvent(Event evt)
	{
		String minStr, maxStr;
		if (evt.target instanceof Button)
		{
			if (evt.target == create && evt.id == Event.ACTION_EVENT)	// When button is clicked
			{
        		create(Integer.valueOf(num.getText()).intValue());
        		return true;					// Generate correct number of tosses
			}
		}
		return super.handleEvent(evt);	// Handle other events as usual
	}
	
	// Calculate probabilities
    public void create(int size)
    {	
    	fw = new FixedWindow(size);
    	Point p = location();
    	fw.move(p.x + 50, p.y + 50);
    	fw.init();
    	fw.show();
       	fw.resize(fw.preferredSize());
   	 	fw.validate();
	}
}




