// BinomialProbabilities.java

// Written by Julian Devlin, 8/97, for the text book
// "Introduction to Probability," by Charles M. Grinstead & J. Laurie Snell

import java.applet.Applet;
import java.awt.*;

public class BinomialProbabilities
	extends java.applet.Applet
{
	TextArea disp;		// Area to display HT
	
	Panel dispArea;
	Panel controls;		// Panel for user controls
	
	Label numl1, numl2, numl3, numl4;			// Controls
	TextField num1, num2, num3, num4;
	Button go;
	
	GridBagLayout gbl;
	GridBagConstraints cc;
		
	// Initialize applet
	public void init()
	{	
		numl1 = new Label("n =");			// Create controls
		num1 = new TextField("10", 4);
		numl2 = new Label("p =");			// Create controls
		num2 = new TextField(".5", 4);
		numl3 = new Label("kmin =");			// Create controls
		num3 = new TextField("4", 4);
		numl4 = new Label("kmax =");			// Create controls
		num4 = new TextField("6", 4);
		go = new Button("Go");
		
		disp = new TextArea(15, 20);		// Create display area
		
		dispArea = new Panel();				// Set up window
		controls = new Panel();
		setLayout(new BorderLayout(5, 5));
		
		add("South", controls);
		add("Center", dispArea);
		
		dispArea.setLayout(new GridLayout(1, 1));
		dispArea.add(disp);
		
		gbl = new GridBagLayout();
		controls.setLayout(gbl);
		
		cc = new GridBagConstraints();
		
		cc.gridx = 0;
		cc.gridy = 0;
		gbl.setConstraints(numl1, cc);
		controls.add(numl1);
		
		cc.gridx = 1;
		gbl.setConstraints(num1, cc);
		controls.add(num1);
		
		cc.gridx = 2;
		gbl.setConstraints(numl2, cc);
		controls.add(numl2);
		
		cc.gridx = 3;
		gbl.setConstraints(num2, cc);
		controls.add(num2);
		
		cc.gridx = 0;
		cc.gridy = 1;
		gbl.setConstraints(numl3, cc);
		controls.add(numl3);
		
		cc.gridx = 1;
		gbl.setConstraints(num3, cc);
		controls.add(num3);
		
		cc.gridx = 2;
		gbl.setConstraints(numl4, cc);
		controls.add(numl4);
		
		cc.gridx = 3;
		gbl.setConstraints(num4, cc);
		controls.add(num4);
		
		cc.gridx = 0;
		cc.gridy = 2;
		cc.gridwidth = 4;
		gbl.setConstraints(go, cc);
		controls.add(go);
		
		validate();
	}
	
	// Handle events
	public boolean handleEvent(Event evt)
	{
		if (evt.target instanceof Button)
		{
			if (evt.target == go && evt.id == Event.ACTION_EVENT)	// When button is clicked
			{
				disp.setText("");			// Reset output window
        		simulate(Integer.valueOf(num1.getText()).intValue(),
        			Float.valueOf(num2.getText()).floatValue(),
        			Integer.valueOf(num3.getText()).intValue(),
        			Integer.valueOf(num4.getText()).intValue());
        		return true;					// Generate correct number of tosses
			}
		}
		return super.handleEvent(evt);	// Handle other events as usual
	}
	
	// Calculate probabilities
    public void simulate(int num, float prob, int min, int max)
    {	
    	float sum = 0;
    	disp.appendText("k            b(n,p,k)\n\n");
    	for (int i = min; i <= max; i++) {
    		sum += Combinatorics.bernoulli(num, prob, i);
    		disp.appendText(String.valueOf(i) + "          " 
    			+ Combinatorics.bernoulli(num, prob, i) + "\n");
	    }
	    disp.appendText("Total:    " + String.valueOf(sum) + "\n");
    }

}




