// Tree.java

// Written by Julian Devlin, 8/97, for the text book
// "Introduction to Probability," by Charles M. Grinstead & J. Laurie Snell

import java.applet.Applet;
import java.awt.*;

public class Tree
	extends java.applet.Applet
{

	TreeCanvas disp;		// Area to display HT
	
	Panel dispArea;
	Panel controls;		// Panel for user controls
	
	Label numl1, numl2, numl3;			// Controls
	TextField num1, num2, num3;
	Button go;
	
	GridBagLayout gbl;
	GridBagConstraints cc;
		
	// Initialize applet
	public void init()
	{	
		numl1 = new Label("p(a) =");			// Create controls
		num1 = new TextField(".2", 4);
		numl2 = new Label("p(c | a) =");			// Create controls
		num2 = new TextField(".3", 4);
		numl3 = new Label("p(c | b) =");			// Create controls
		num3 = new TextField(".4", 4);
		go = new Button("Go");
		
		disp = new TreeCanvas(Float.valueOf(num1.getText()).floatValue(),
        	Float.valueOf(num2.getText()).floatValue(),
        	Float.valueOf(num3.getText()).floatValue());		// Create display area
		
		dispArea = new Panel();				// Set up window
		controls = new Panel();
		setLayout(new BorderLayout(5, 5));
		
		add("South", controls);
		add("Center", dispArea);
		
		dispArea.setLayout(new GridLayout(1, 1));
		dispArea.add(disp);
		
		gbl = new GridBagLayout();
		controls.setLayout(gbl);
		
		cc = new GridBagConstraints();
		
		cc.gridx = 1;
		cc.gridy = 0;
		gbl.setConstraints(numl1, cc);
		controls.add(numl1);
		
		cc.gridx = 2;
		gbl.setConstraints(num1, cc);
		controls.add(num1);
		
		cc.gridx = 0;
		cc.gridy = 1;
		gbl.setConstraints(numl2, cc);
		controls.add(numl2);
		
		cc.gridx = 1;
		gbl.setConstraints(num2, cc);
		controls.add(num2);
		
		cc.gridx = 2;
		gbl.setConstraints(numl3, cc);
		controls.add(numl3);
		
		cc.gridx = 3;
		gbl.setConstraints(num3, cc);
		controls.add(num3);
		
		cc.gridx = 0;
		cc.gridy = 2;
		cc.gridwidth = 4;
		gbl.setConstraints(go, cc);
		controls.add(go);
		
		validate();
	}
	
	// Handle events
	public boolean handleEvent(Event evt)
	{
		if (evt.target instanceof Button)
		{
			if (evt.target == go && evt.id == Event.ACTION_EVENT)	// When button is clicked
			{
				simulate(Float.valueOf(num1.getText()).floatValue(),
        			Float.valueOf(num2.getText()).floatValue(),
        			Float.valueOf(num3.getText()).floatValue());
        		return true;					// Generate correct number of tosses
			}
		}
		return super.handleEvent(evt);	// Handle other events as usual
	}
	
	 public void simulate(float pa, float pcga, float pcgb)
    {	
    	dispArea.remove(disp);
		disp = new TreeCanvas(pa, pcga, pcgb);
		dispArea.add(disp);
		validate();
	}
}


